#include <stdio.h>
#include <math.h>

/*
-------------------------------------------------------------------------------
Model presa-depredador (normalitzat)
-------------------------------------------------------------------------------
Dades: dt (mida del pas), imax (passos que es volen calcular), jmax
       (iteracions per estabilitzar), nx0 (nombre inicial especie x),
       ny0 (nombre inicial especie y), aa (influencia d'y sobre x), bb
       (influencia de x sobre y), rx (taxa de creixement x), dd (mortalitat
       especie y), Kx (capacitat especie x)
Resultats: Al fitxer "edos4.dat". Cada fila representa un instant de temps.
           La primera columna es el temps, la segona el nombre (sense
           normalitzar) de membres de l'especie x i la tercera el mateix
           pero de l'especie y.
Dades de prova: dt=0.05 imax=200 jmax=1 nx0=200 ny0=300 aa=0.00075 bb=0.75
                rx=2.0 dd=1.0 Kx=1000 ==>
                0.000000 200.000000 300.000000
                0.050000 213.750000 286.687500
                0.100000 228.258118 274.076599
                0.150000 243.527740 262.132263
                0.200000 259.556061 250.821045  
                  ...      ....        ...
Observacions: Totes les quantitats es refereixen al model sense normalitzar.
              Nomes jmax=1 esta justificat teoricament.
-------------------------------------------------------------------------------
*/

main()
{

int i,j,imax,jmax;
float dx,dy,dt,x0,y0,t0,x,y,t,xf,yf,tf,aa,bb,dd,
      xm,ym,tm,Kx,rx,nx0,ny0;
FILE *arxiu;

printf("Tamany del pas: ");
scanf("%f",&dt);
printf("Passos que vols calcular: ");
scanf("%d",&imax);
printf("Iteracions per estabilitzar: ");
scanf("%d",&jmax);
printf("Nombre inicial especie x: ");
scanf("%f",&nx0);
printf("Nombre inicial especie y: ");
scanf("%f",&ny0);
printf("Influencia especie y sobre x (a): ");
scanf("%f",&aa);
printf("Influencia especie x sobre y (b): ");
scanf("%f",&bb);
printf("Taxa de creixement especie x (rx): ");
scanf("%f",&rx);
printf("Mortalitat especie y (d): ");
scanf("%f",&dd);
printf("Capacitat especie x: ");
scanf("%f",&Kx);

arxiu=fopen("edos4.dat","w");
t0=0;
x=nx0;
y=ny0;
t=t0;
xf=nx0;
yf=ny0;
fprintf(arxiu,"%f %f %f\n",t0,nx0,ny0);
for(i=0;i<imax;i++)   
   {
   tm=t+dt/2.0;
   for(j=0;j<jmax;j++)
      {
      xm=(x+xf)/2.0;
      ym=(y+yf)/2.0;
      dx=dt*xm*(rx*(Kx-xm)/Kx-aa*ym);
      dy=dt*ym*(aa*bb*xm-dd);
      xf=x+dx;
      yf=y+dy;
      }
   x=xf;
   y=yf;
   t=t+dt;         
   fprintf(arxiu,"%f %f %f\n",t,x,y);
   }
fclose(arxiu);
}
